Package com.collabnet.ce.soap60.webservices.page

# Interface IPageAppSoap

All Known Implementing Classes:
  `PageAppSoap`, `PageAppSoapMockStub`, `PageAppSoapStub`

public interface IPageAppSoap

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `addPageImage(String sessionId, String projectId, String fileId, String filename, String mimetype)`
  Adds an uploaded file as an image for a page.
  `PageComponentSoapDO`
  `createComponent(String sessionId, String pageId, String compName, String componentType, boolean topOfPage, int visibility, SoapNamedValues attributes, String content)`
  Creates a page component.
  `PageComponent2SoapDO`
  `createComponent2(String sessionId, String pageId, String compName, String componentType, boolean topOfPage, int visibility, SoapNamedValues attributes, String content)`
  Creates a page component.
  `PageSoapDO`
  `createPage(String sessionId, String projectId, String parentId, String title, boolean visible, boolean freeform)`
  Creates a new project page.
  `void`
  `deletePage(String sessionId, String pageId)`
  Deletes an existing page
  `void`
  `deletePageComponent(String sessionId, String pageComponentId)`
  Deletes an existing page component
  `void`
  `deletePageImage(String sessionId, String projectId, String attachmentId)`
  Deletes the specified attachment of the specified object.
  `PageComponent2SoapDO`
  `getPageComponent(String sessionId, String pageComponentId)`
  Gets page component meta data and settings for a given page component id.
  `PageComponentSoapDO[]`
  `getPageComponents(String sessionId, String pageId)`
  Gets an array of page components for a page (in the correct order)
  `PageSoapDO`
  `getPageData(String sessionId, String pageId)`
  Gets a project page.
  `String`
  `getPageImageUrl(String sessionId, String projectId, String attachmentId)`
  Gets relative URL to access to the uploaded image from an HTML page.
  `PageSoapList`
  `getPageList(String sessionId, String projectId)`
  Gets all pages for a user in the specified project (in the correct order).
  `String`
  `getTextComponentContent(String sessionId, String pageCompId)`
  Gets the content of a Text component.
  `AttachmentSoapList`
  `listPageImages(String sessionId, String projectId)`
  Lists the images for a project.
  `void`
  `movePage(String sessionId, String pageFolderPath, String destPath)`
  Moves a page (including sub pages and contents).
  `void`
  `setComponentDisplayOrder(String sessionId, String pageId, String[] componentIds)`
  Sets the display order for components within a page
  `void`
  `setLifecycleMetricComponentContent(String sessionId, PageComponent2SoapDO pageComponent, String content)`
  Sets Lifecycle metric component.
  `void`
  `setPageComponentData(String sessionId, PageComponentSoapDO pageComponent)`
  Updates a page component
  `void`
  `setPageData(String sessionId, PageSoapDO pageData)`
  Edits an existing page.
  `boolean`
  `setPageDisplayOrder(String sessionId, String folderId, String[] childrenPageIds)`
  Sets the page display order.
  `void`
  `setTextComponentContent(String sessionId, String pageCompId, String content)`
  Sets the content of a Text component.

- ## Method Details

  - ### getPageData

    PageSoapDO getPageData(String sessionId, String pageId) throws RemoteException
    Gets a project page. This API only fetches the page data and does not fetch the component contents.
    Parameters:
      `sessionId` - User session id.
      `pageId` - the pageId for which data is to be fetched.
    Returns:
      the page data
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### getTextComponentContent

    String getTextComponentContent(String sessionId, String pageCompId) throws RemoteException
    Gets the content of a Text component.
    Parameters:
      `sessionId` - User session id.
      `pageCompId` - page component id for which the content/source is to be fetched.
    Returns:
      content of the text component as string
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `InvalidComponentTypeFault` - if the type of the component is not Text
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### setTextComponentContent

    void setTextComponentContent(String sessionId, String pageCompId, String content) throws RemoteException
    Sets the content of a Text component.
    Parameters:
      `sessionId` - User session id.
      `pageCompId` - page component id for which the content/source is to be fetched.
      `content` - the new content
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `InvalidComponentTypeFault` - if the type of the component is not Text
      `VersionMismatchFault` - when component data is stale
      `IllegalArgumentFault` - for invalid content
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### setLifecycleMetricComponentContent

    void setLifecycleMetricComponentContent(String sessionId, PageComponent2SoapDO pageComponent, String content) throws RemoteException
    Sets Lifecycle metric component. The API replaces the existing HTML source and other metric properties.
    Parameters:
      `sessionId` - User session id.
      `pageComponent` - the page component to be updated.
      `content` - the html content
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `InvalidComponentTypeFault` - if the type of the component is not metrics
      `VersionMismatchFault` - when component data is stale
      `IllegalArgumentFault` - for invalid content
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      7.0

  - ### getPageList

    PageSoapList getPageList(String sessionId, String projectId) throws RemoteException
    Gets all pages for a user in the specified project (in the correct order).
    Parameters:
      `sessionId` - User session id.
      `projectId` - the project for which the pages are to be fetched
    Returns:
      list of pages for the user in the project
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### createPage

    PageSoapDO createPage(String sessionId, String projectId, String parentId, String title, boolean visible, boolean freeform) throws RemoteException
    Creates a new project page.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Id of the project in which the page is to be created
      `parentId` - parent folder id under which the page is to be created
      `title` - title of the page
      `visible` - visibility of the page
      `freeform` - true if the page link must be hidden in the left navigation
    Returns:
      the newly created page
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `ObjectAlreadyExistsFault` - If a page with the same name already exists in the project
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### setPageData

    void setPageData(String sessionId, PageSoapDO pageData) throws RemoteException
    Edits an existing page. This API will not modify the component data.
    Parameters:
      `sessionId` - User session id.
      `pageData` - the page to be edited.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `VersionMismatchFault` - when page data is stale
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### getPageComponents

    PageComponentSoapDO[] getPageComponents(String sessionId, String pageId) throws RemoteException
    Gets an array of page components for a page (in the correct order)
    Parameters:
      `sessionId` - User session id.
      `pageId` - the id of the page from which to get the list of components
    Returns:
      array of page components
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### deletePage

    void deletePage(String sessionId, String pageId) throws RemoteException
    Deletes an existing page
    Parameters:
      `sessionId` - User session id.
      `pageId` - the page to be deleted.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `CannotDeleteHomePageFault` - when the user tries to delete the home page.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### deletePageComponent

    void deletePageComponent(String sessionId, String pageComponentId) throws RemoteException
    Deletes an existing page component
    Parameters:
      `sessionId` - User session id.
      `pageComponentId` - the id of the page component to be deleted.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page id is invalid.
      `PermissionDeniedFault` - when the specified page id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### setComponentDisplayOrder

    void setComponentDisplayOrder(String sessionId, String pageId, String[] componentIds) throws RemoteException
    Sets the display order for components within a page
    Parameters:
      `sessionId` - User session id.
      `pageId` - the id of the page where the components belong
      `componentIds` - ids of component in the order which is to be set
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### createComponent

    PageComponentSoapDO createComponent(String sessionId, String pageId, String compName, String componentType, boolean topOfPage, int visibility, SoapNamedValues attributes, String content) throws RemoteException
    Creates a page component.
    Parameters:
      `sessionId` - User session id.
      `pageId` - the id of the page where the component is to be created.
      `compName` - component name
      `componentType` - component type.
      `topOfPage` - true if the component is to be created at top of the page
      `visibility` - defines the visibility of this component, 1= visible, 0 = hidden.
      `attributes` - component attributes.
      `content` - text component content, applicable for Text components and Lifecycle metrics components.
    Returns:
      the newly created component
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `IllegalArgumentFault` - for incorrect parameter values
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `ObjectAlreadyExistsFault` - If a component with the same name already exists in the page
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### createComponent2

    PageComponent2SoapDO createComponent2(String sessionId, String pageId, String compName, String componentType, boolean topOfPage, int visibility, SoapNamedValues attributes, String content) throws RemoteException
    Creates a page component.
    Parameters:
      `sessionId` - User session id.
      `pageId` - the id of the page where the component is to be created.
      `compName` - component name
      `componentType` - component type.
      `topOfPage` - true if the component is to be created at top of the page
      `visibility` - defines the visibility of this component, 1= visible, 0 = hidden.
      `attributes` - component attributes.
      `content` - text component content, applicable for Text components and Lifecycle metrics components.
    Returns:
      the newly created component
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `IllegalArgumentFault` - for incorrect parameter values
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `ObjectAlreadyExistsFault` - If a component with the same name already exists in the page
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      7.0

  - ### setPageComponentData

    void setPageComponentData(String sessionId, PageComponentSoapDO pageComponent) throws RemoteException
    Updates a page component
    Parameters:
      `sessionId` - User session id.
      `pageComponent` - the page component to be updated.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified page id is invalid.
      `PermissionDeniedFault` - when the specified page id is invalid.
      `VersionMismatchFault` - when the component data is stale.
      `IllegalArgumentFault` - for incorrect data.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### setPageDisplayOrder

    boolean setPageDisplayOrder(String sessionId, String folderId, String[] childrenPageIds) throws RemoteException
    Sets the page display order. This API will not modify the component data.
    Parameters:
      `sessionId` - User session id.
      `folderId` - the folder to be used.
      `childrenPageIds` - page keys in the new intended order based on array order must pass in all pages.
    Returns:
      true is the update went perfectly
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### movePage

    void movePage(String sessionId, String pageFolderPath, String destPath) throws RemoteException
    Moves a page (including sub pages and contents).
    Parameters:
      `sessionId` - User session id.
      `pageFolderPath` - The path to the page to move
      `destPath` - The path of the destination parent folder
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified folder component id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      5.0

  - ### addPageImage

    String addPageImage(String sessionId, String projectId, String fileId, String filename, String mimetype) throws RemoteException
    Adds an uploaded file as an image for a page.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
      `fileId` - Image file ID returned by FileStorageApp/SimpleFileStorageApp webservice.
      `filename` - Image file name.
      `mimetype` - Image file type.
    Returns:
      attachment id of the added image
    Throws:
      `InvalidSessionFault` - when the sessionId is invalid.
      `PermissionDeniedFault` - when permission is denied for the specified operation.
      `NoSuchObjectFault` - when the specified object is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.3

  - ### listPageImages

    AttachmentSoapList listPageImages(String sessionId, String projectId) throws RemoteException
    Lists the images for a project.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
    Returns:
      List of page images as AttachmentSoapList.
    Throws:
      `InvalidSessionFault` - when the sessionId is invalid.
      `PermissionDeniedFault` - when permission is denied for the specified operation.
      `NoSuchObjectFault` - when the specified object is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.3

  - ### getPageImageUrl

    String getPageImageUrl(String sessionId, String projectId, String attachmentId) throws RemoteException
    Gets relative URL to access to the uploaded image from an HTML page.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
      `attachmentId` - Attachment id of the image.
    Returns:
      the relative URL for the image.
    Throws:
      `InvalidSessionFault` - when the sessionId is invalid.
      `PermissionDeniedFault` - when permission is denied for the specified operation.
      `NoSuchObjectFault` - when the specified object is invalid.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.3

  - ### deletePageImage

    void deletePageImage(String sessionId, String projectId, String attachmentId) throws RemoteException
    Deletes the specified attachment of the specified object.
    Parameters:
      `sessionId` - User session id.
      `projectId` - Project id.
      `attachmentId` - The attachment id.
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `NoSuchObjectFault` - when the specified object id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `SystemFault` - when an unexpected system error occurs.
      `RemoteException`
    Since:
      5.3

  - ### getPageComponent

    PageComponent2SoapDO getPageComponent(String sessionId, String pageComponentId) throws RemoteException
    Gets page component meta data and settings for a given page component id.
    Parameters:
      `sessionId` - User session id.
      `pageComponentId` - the id of the page component from which to get the component
    Returns:
      page component
    Throws:
      `InvalidSessionFault` - when the specified session id is invalid.
      `PermissionDeniedFault` - when the user has insufficient privileges.
      `NoSuchObjectFault` - when the specified page component id is invalid.
      `SystemFault` - when an unexpected system level error occurs.
      `RemoteException`
    Since:
      7.0